require 'chef/knife'
require 'json'

module Pantry
  class PantryLookup < Chef::Knife

    banner "knife pantry lookup COOKBOOK ENVIRONMENT (options)"

    def run
      cbk = name_args.first
      env = name_args.last

      get_env(env)
      version = get_cbk_versions(env, cbk)
      get_past_versions(cbk, version)
    end

    def get_env(env)
      environments = []
      for key in rest.get_rest('environments')
        environments.push(key[0])
      end
      if !(environments.include?(env))
        puts "Specified environment does not exist"
      else
        puts "[Environment found!]   Looking for cookbook..."
      end
    end

    def get_cbk_versions(env, cbk)
      cookbooks = rest.get_rest("environments/#{env}/cookbooks")
      if !(cookbooks.has_key?(cbk))
        puts "#{cbk} not found in #{env}"
      else
        puts "[Cookbook found!]    Checking current version..."
        version = cookbooks[cbk]['versions'][0]['version']
        puts "[Version found!]    Finding latest releases..."
      end
      return version
    end

    def get_past_versions(cbk, version)
      available_versions= rest.get_rest("cookbooks/#{cbk}")
      puts "[Releases found!]"
      available_versions[cbk]['versions'][0..4].each { |release|
        if release['version'] == version
          puts release['version'] + "  <== Current version"
        else
          puts release['version']
        end
      }
    end
  end
end
